<!-- Author: Benjamin George -->

<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>

<script language="JavaScript" src='common/scripts/jquery-ui.js'></script>
<link rel="stylesheet" href="common/styles/jquery-ui.css">

<style>
#ulhead { list-style-type: none; margin: 0; padding: 0; width: 60%; background-color:#43698F; text-align:left;

border-color:#43698F;
border-top-style:solid;
border-bottom:none;
border-left:none;
border-right:none;
border-width:2px;}

.tabs .current a {
   background-color:#f0f1f2;
}
.tabs .current a span {
   background-color:#f0f1f2;
}

 .ulhead li { margin: 0 3px 3px 3px; padding: 0.4em; padding-left: 1.5em; font-size: 1.4em; height: 18px; cursor:hand;}
 .sortable { list-style-type: none; margin: 0; padding: 0; width: 60%; }
 .sortable li { margin: 0 3px 3px 3px; padding: 0.4em; padding-left: 1.5em; font-size: 1.4em; height: 18px; cursor:hand; text-align:left;}
 .sortable li span { position: absolute; margin-left: -1.3em; }
</style>
<script>

function prioritizeRules(){
	 if(document.getElementById("prioritizeRulesBlock").style.display=='none'){
		  document.getElementById("prioritizeRulesBlock").style.display='block';
		  document.getElementById("ruleSearchBlock").style.display='none';
		  document.getElementById("ruleListTable").style.display='none';
		  document.getElementById("preTableBlock").style.display='none';
	 }

	 document.getElementById('preRuleAuth' + "Tab").className = "current";

  bar.setEnabled(7, false);
}

  $(function() {

    $("#sortablePreAuth").sortable({
    	 cancel: ".ui-state-disabled"
    });

    $("#sortablePostAuth").sortable({
    	  cancel: ".ui-state-disabled"
    });

    $("#sortablePreVar").sortable({
   	 cancel: ".ui-state-disabled"
   });

   $("#sortablePostVar").sortable({
   	  cancel: ".ui-state-disabled"
   });

   $("#sortablePreQueue").sortable({
  	 cancel: ".ui-state-disabled"
  });

  $("#sortablePostQueue").sortable({
  	  cancel: ".ui-state-disabled"
  });

    $( "#sortablePostAuth li, #sortablePreAuth li, #sortablePostVar li, #sortablePreVar li, #sortablePostQueue li, #sortablePreQueue li" ).disableSelection();

  });

  function savePriorities(){

	   formElem = document.ruleForm;

	   var str = "";
	   var dependenciesMoved = "";
	   var strName, strValue, listItem;

	   <c:forEach var="rule" items="${preRulesAuth}">

 	    listItem = document.getElementById('${rule.baseRuleId}'+"_"+'${rule.workflowState}');
 	    strValue = $("#sortablePreAuth li").index(listItem);

	     if(strValue!=${rule.executionOrderPriority}){
	       <c:if test="${not empty rule.ruleDependencies}">
	         <c:forEach var="ruleDependency" items="${rule.ruleDependencies}">

	           dependentRuleCoding = document.getElementById('${ruleDependency}' + "_Coding");
	           dependentRuleTesting = document.getElementById('${ruleDependency}' + "_Testing");
	           dependentRuleProduction = document.getElementById('${ruleDependency}' + "_Production");

	           dependentRuleCodingIndex = $("#sortablePreAuth li").index(dependentRuleCoding);
	           dependentRuleTestingIndex = $("#sortablePreAuth li").index(dependentRuleTesting);
	           dependentRuleProductionIndex = $("#sortablePreAuth li").index(dependentRuleProduction);

	           if(strValue < dependentRuleCodingIndex ||
	        	  strValue < dependentRuleTestingIndex ||
	        	  strValue < dependentRuleProductionIndex)
	           {
	             dependenciesMoved = dependenciesMoved+":"+${rule.baseRuleId};
     		   }

	         </c:forEach>
	 	   </c:if>
	 	   strName = ${rule.id};
	 	   str = str + strName+":"+strValue + ",";
         }

	   </c:forEach>

	   <c:forEach var="rule" items="${postRulesAuth}">

	     listItem = document.getElementById('${rule.baseRuleId}'+"_"+'${rule.workflowState}');
	     strValue = $("#sortablePostAuth li").index(listItem);

	     if(strValue!=${rule.executionOrderPriority}){
	       <c:if test="${not empty rule.ruleDependencies}">
	         <c:forEach var="ruleDependency" items="${rule.ruleDependencies}">

	           dependentRuleCoding = document.getElementById('${ruleDependency}' + "_Coding");
	           dependentRuleTesting = document.getElementById('${ruleDependency}' + "_Testing");
	           dependentRuleProduction = document.getElementById('${ruleDependency}' + "_Production");

	           dependentRuleCodingIndex = $("#sortablePostAuth li").index(dependentRuleCoding);
	           dependentRuleTestingIndex = $("#sortablePostAuth li").index(dependentRuleTesting);
	           dependentRuleProductionIndex = $("#sortablePostAuth li").index(dependentRuleProduction);

	           if(strValue < dependentRuleCodingIndex ||
	        	  strValue < dependentRuleTestingIndex ||
	        	  strValue < dependentRuleProductionIndex)
	           {
	             dependenciesMoved = dependenciesMoved+":"+${rule.baseRuleId};
   		   	   }

	         </c:forEach>
	 	   </c:if>
		   strName = ${rule.id};
		   str = str + strName+":"+strValue + ",";
	     }

	   </c:forEach>

	   <c:forEach var="rule" items="${preRulesVar}">

	     listItem = document.getElementById('${rule.baseRuleId}'+"_"+'${rule.workflowState}');
	     strValue = $("#sortablePreVar li").index(listItem);

	     if(strValue!=${rule.executionOrderPriority}){
	       <c:if test="${not empty rule.ruleDependencies}">
	         <c:forEach var="ruleDependency" items="${rule.ruleDependencies}">

	           dependentRuleCoding = document.getElementById('${ruleDependency}' + "_Coding");
	           dependentRuleTesting = document.getElementById('${ruleDependency}' + "_Testing");
	           dependentRuleProduction = document.getElementById('${ruleDependency}' + "_Production");

	           dependentRuleCodingIndex = $("#sortablePreVar li").index(dependentRuleCoding);
	           dependentRuleTestingIndex = $("#sortablePreVar li").index(dependentRuleTesting);
	           dependentRuleProductionIndex = $("#sortablePreVar li").index(dependentRuleProduction);

	           if(strValue < dependentRuleCodingIndex ||
	        	  strValue < dependentRuleTestingIndex ||
	        	  strValue < dependentRuleProductionIndex)
	           {
	             dependenciesMoved = dependenciesMoved+":"+${rule.baseRuleId};
   		   	   }

	         </c:forEach>
	 	   </c:if>
		   strName = ${rule.id};
		   str = str + strName+":"+strValue + ",";
	     }

	   </c:forEach>

	   <c:forEach var="rule" items="${postRulesVar}">

	     listItem = document.getElementById('${rule.baseRuleId}'+"_"+'${rule.workflowState}');
	     strValue = $("#sortablePostVar li").index(listItem);

	     if(strValue!=${rule.executionOrderPriority}){
	       <c:if test="${not empty rule.ruleDependencies}">
	         <c:forEach var="ruleDependency" items="${rule.ruleDependencies}">

	           dependentRuleCoding = document.getElementById('${ruleDependency}' + "_Coding");
	           dependentRuleTesting = document.getElementById('${ruleDependency}' + "_Testing");
	           dependentRuleProduction = document.getElementById('${ruleDependency}' + "_Production");

	           dependentRuleCodingIndex = $("#sortablePostVar li").index(dependentRuleCoding);
	           dependentRuleTestingIndex = $("#sortablePostVar li").index(dependentRuleTesting);
	           dependentRuleProductionIndex = $("#sortablePostVar li").index(dependentRuleProduction);

	           if(strValue < dependentRuleCodingIndex ||
	        	  strValue < dependentRuleTestingIndex ||
	        	  strValue < dependentRuleProductionIndex)
	           {
	             dependenciesMoved = dependenciesMoved+":"+${rule.baseRuleId};
   		   	   }

	         </c:forEach>
	 	   </c:if>
		   strName = ${rule.id};
		   str = str + strName+":"+strValue + ",";
	     }

	   </c:forEach>

	   <c:forEach var="rule" items="${preRulesQueue}">

	     listItem = document.getElementById('${rule.baseRuleId}'+"_"+'${rule.workflowState}');
	     strValue = $("#sortablePreQueue li").index(listItem);

	     if(strValue!=${rule.executionOrderPriority}){
	       <c:if test="${not empty rule.ruleDependencies}">
	         <c:forEach var="ruleDependency" items="${rule.ruleDependencies}">

	           dependentRuleCoding = document.getElementById('${ruleDependency}' + "_Coding");
	           dependentRuleTesting = document.getElementById('${ruleDependency}' + "_Testing");
	           dependentRuleProduction = document.getElementById('${ruleDependency}' + "_Production");

	           dependentRuleCodingIndex = $("#sortablePreQueue li").index(dependentRuleCoding);
	           dependentRuleTestingIndex = $("#sortablePreQueue li").index(dependentRuleTesting);
	           dependentRuleProductionIndex = $("#sortablePreQueue li").index(dependentRuleProduction);

	           if(strValue < dependentRuleCodingIndex ||
	        	  strValue < dependentRuleTestingIndex ||
	        	  strValue < dependentRuleProductionIndex)
	           {
	             dependenciesMoved = dependenciesMoved+":"+${rule.baseRuleId};
   		   	   }

	         </c:forEach>
	 	   </c:if>
		   strName = ${rule.id};
		   str = str + strName+":"+strValue + ",";
	     }

	   </c:forEach>

	   <c:forEach var="rule" items="${postRulesQueue}">

	     listItem = document.getElementById('${rule.baseRuleId}'+"_"+'${rule.workflowState}');
	     strValue = $("#sortablePostQueue li").index(listItem);

	     if(strValue!=${rule.executionOrderPriority}){
		     <c:if test="${not empty rule.ruleDependencies}">
		        <c:forEach var="ruleDependency" items="${rule.ruleDependencies}">

		           dependentRuleCoding = document.getElementById('${ruleDependency}' + "_Coding");
		           dependentRuleTesting = document.getElementById('${ruleDependency}' + "_Testing");
		           dependentRuleProduction = document.getElementById('${ruleDependency}' + "_Production");

		           dependentRuleCodingIndex = $("#sortablePostQueue li").index(dependentRuleCoding);
		           dependentRuleTestingIndex = $("#sortablePostQueue li").index(dependentRuleTesting);
		           dependentRuleProductionIndex = $("#sortablePostQueue li").index(dependentRuleProduction);

		           if(strValue < dependentRuleCodingIndex ||
		        	  strValue < dependentRuleTestingIndex ||
		        	  strValue < dependentRuleProductionIndex)
		           {
		             dependenciesMoved = dependenciesMoved+":"+${rule.baseRuleId};
	   		   	   }

		         </c:forEach>
		 	   </c:if>
		 	   strName = ${rule.id};
		 	   str = str + strName+":"+strValue + ",";
	     }

	   </c:forEach>

	   if(dependenciesMoved!=""){
	     alert("<fmt:message key='rules.rulePriority.warning.txt' />");{return false};
	   }

       ele = document.createElement("input");
	   ele.type = "hidden";
	   ele.name = "rulesPriorityChanged";
	   ele.value = str;
	   formElem.appendChild(ele);

	   ele1 = document.createElement("input");
	   ele1.type = "hidden";
	   ele1.name = "activeTab";
	   if(document.getElementById("postRuleAuthDiv").style.display!="none"){
	     ele1.value = "postRuleAuthDiv";
	   }
	   if(document.getElementById("preRuleAuthDiv").style.display!="none"){
		     ele1.value = "preRuleAuthDiv";
		  }
	   if(document.getElementById("postRuleVarDiv").style.display!="none"){
		     ele1.value = "postRuleVarDiv";
		  }
		  if(document.getElementById("preRuleVarDiv").style.display!="none"){
			    ele1.value = "preRuleVarDiv";
			 }
		  if(document.getElementById("postRuleQueueDiv").style.display!="none"){
			    ele1.value = "postRuleQueueDiv";
			 }
			 if(document.getElementById("preRuleQueueDiv").style.display!="none"){
			    ele1.value = "preRuleQueueDiv";
			 }
	   formElem.appendChild(ele1);

	   formElem.submit();
  }

  function resetPriorities(){
	   formElem = document.ruleForm;
	   ele1 = document.createElement("input");
	   ele1.type = "hidden";
	   ele1.name = "activeTab";
	   if(document.getElementById("postRuleAuthDiv").style.display!="none"){
	     ele1.value = "postRuleAuthDiv";
	   }
	   if(document.getElementById("preRuleAuthDiv").style.display!="none"){
	     ele1.value = "preRuleAuthDiv";
	   }
	   if(document.getElementById("postRuleVarDiv").style.display!="none"){
	     ele1.value = "postRuleVarDiv";
	   }
	   if(document.getElementById("preRuleVarDiv").style.display!="none"){
	     ele1.value = "preRuleVarDiv";
	   }
	   if(document.getElementById("postRuleQueueDiv").style.display!="none"){
		 ele1.value = "postRuleQueueDiv";
	   }
	   if(document.getElementById("preRuleQueueDiv").style.display!="none"){
		 ele1.value = "preRuleQueueDiv";
	   }
	   formElem.appendChild(ele1);
	   formElem.submit();
  }

  function cancelPriorities(){
	   formEmpty = document.emptyRuleForm;
	   formEmpty.submit();
  }

  var activeTab = new Array('preRuleAuth');

  function swapGridContents(gridName,gridNum)
  {
     if (document.getElementById(gridName + "Tab") && document.getElementById(gridName + "Div"))
     {
       var prev=activeTab[gridNum-1];
       document.getElementById(prev+"Div").style.display = "none";
       document.getElementById(prev + "Tab").className = "normal";
       document.getElementById(gridName + "Div").style.display = "block";
       document.getElementById(gridName + "Tab").className = "current";
       window.focus();
       //-document.getElementById(gridName + "Tab").blur();
       //eval("currGridName"+gridNum) = gridName;
       activeTab[gridNum-1]=gridName;
       bypassSaveCheck = false;
     }
  }

</script>

<div id="prioritizeRulesBlock" style="display:none;">
<table>
  <tr>
   <td>
   		<span style="font-size:10pt;margin:0px 0px 0px 0px;color:#353535;font-weight:bold;"><fmt:message key='rules.rulePriority.title.txt' /> &nbsp;&nbsp;</span><span style="margin-left:221px;"></span>
   </td>
    <td>

 <table border="0" cellspacing="0" cellpadding="0" class="primaryMenuNonSelectedOuterTable">
		<tr>
			<td><img src="common/images/TabUpperLeftFirst.gif" border="0" alt=""></td>
			<td valign="top"><img src="common/images/TabTop.gif" border="0" height="5" width="100%" alt=""></td>
			<td><img src="common/images/TabUpperRight.gif" border="0" alt=""></td>
		</tr>
		<tr>
			<td class="tab-left-first-image"/>
			<td nowrap>
				<table border="0" cellspacing="0" cellpadding="0" height="100%">
					<tr>
						<td style="background-color:#42668F; padding:0px 8px 0px 8px; cursor:pointer;"> <a class="menu" id="save" style="white-space:nowrap;" target="_top" onMouseOver="animate('save','ffffff','c3d5e5',250)" onMouseOut="animate('save','c3d5e5','ffffff',0)" onMouseDown="animate('save','c3d5e5','353535',0)" onclick="javascript:savePriorities()"><fmt:message key='rules.rulePriority.save.txt' /></a></td>
					</tr>
	  			</table>
	  		</td>
			<td class="tab-right-image"/>
		</tr>
		<tr>
			<td><img src="common/images/TabBottomLeft.gif" border="0" alt=""></td>
			<td valign="top"  class="tab"><img src="common/images/TabBottom.gif" border="0" height="5" width="100%" alt=""></td>
			<td><img src="common/images/TabBottomRight.gif" border="0" alt=""></td>
		</tr>
	</table>

   </td>
   <td>

 <table border="0" cellspacing="0" cellpadding="0" class="primaryMenuNonSelectedOuterTable">
		<tr>
			<td><img src="common/images/TabUpperLeftFirst.gif" border="0" alt=""></td>
			<td valign="top"><img src="common/images/TabTop.gif" border="0" height="5" width="100%" alt=""></td>
			<td><img src="common/images/TabUpperRight.gif" border="0" alt=""></td>
		</tr>
		<tr>
			<td class="tab-left-first-image"/>
			<td nowrap>
				<table border="0" cellspacing="0" cellpadding="0" height="100%">
					<tr>
						<td style="background-color:#42668F; padding:0px 8px 0px 8px; cursor:pointer;"> <a class="menu" id="reset" style="white-space:nowrap;" target="_top" onMouseOver="animate('reset','ffffff','c3d5e5',250)" onMouseOut="animate('reset','c3d5e5','ffffff',0)" onMouseDown="animate('reset','c3d5e5','353535',0)" onclick="javascript:resetPriorities()"><fmt:message key='rules.rulePriority.reset.txt' /></a></td>
					</tr>
	  			</table>
	  		</td>
			<td class="tab-right-image"/>
		</tr>
		<tr>
			<td><img src="common/images/TabBottomLeft.gif" border="0" alt=""></td>
			<td valign="top"  class="tab"><img src="common/images/TabBottom.gif" border="0" height="5" width="100%" alt=""></td>
			<td><img src="common/images/TabBottomRight.gif" border="0" alt=""></td>
		</tr>
	</table>

   </td>
   <td>

 <table border="0" cellspacing="0" cellpadding="0" class="primaryMenuNonSelectedOuterTable">
		<tr>
			<td><img src="common/images/TabUpperLeftFirst.gif" border="0" alt=""></td>
			<td valign="top"><img src="common/images/TabTop.gif" border="0" height="5" width="100%" alt=""></td>
			<td><img src="common/images/TabUpperRight.gif" border="0" alt=""></td>
		</tr>
		<tr>
			<td class="tab-left-first-image"/>
			<td nowrap>
				<table border="0" cellspacing="0" cellpadding="0" height="100%">
					<tr>
						<td style="background-color:#42668F; padding:0px 8px 0px 8px; cursor:pointer;"> <a class="menu" id="cancel" style="white-space:nowrap;" target="_top" onMouseOver="animate('cancel','ffffff','c3d5e5',250)" onMouseOut="animate('cancel','c3d5e5','ffffff',0)" onMouseDown="animate('cancel','c3d5e5','353535',0)" onclick="javascript:cancelPriorities()"><fmt:message key='rules.rulePriority.return.txt' /></a></td>
					</tr>
	  			</table>
	  		</td>
			<td class="tab-right-image"/>
		</tr>
		<tr>
			<td><img src="common/images/TabBottomLeft.gif" border="0" alt=""></td>
			<td valign="top"  class="tab"><img src="common/images/TabBottom.gif" border="0" height="5" width="100%" alt=""></td>
			<td><img src="common/images/TabBottomRight.gif" border="0" alt=""></td>
		</tr>
	</table>

  </td>
</tr>
</table>

<br/><br/><fmt:message key='rules.rulePriority.directions.txt' />
<br/><br/><br/>

<form name="emptyRuleForm" id="emptyRuleForm" action="<c:url value='/r_rules.do?method=listRules&workflow=Coding&userId=${userId}'/>" method="post">
</form>

<table name="searchView" cellspacing="0" cellpadding="0" style="margin-top:0px">
         <THEAD>
            <TR><TH scope="col" style="margin:0px;padding:0px;border:0px;" nowrap>
               <div class="tabs">
                  <ul>
                    <c:if test="${isTenantInstall==true}">
                      <li id="preRuleAuthTab"><a href="JavaScript:swapGridContents('preRuleAuth',1);"><span><fmt:message key='rules.rulePriority.preRulesTab.txt' /></span></a></li>
                      <li id="postRuleAuthTab"><a href="JavaScript:swapGridContents('postRuleAuth',1);"><span><fmt:message key='rules.rulePriority.postRulesTab.txt' /></span></a></li>
                    </c:if>
					<c:if test="${isTenantInstall==false}">
					  <li id="preRuleAuthTab"><a href="JavaScript:swapGridContents('preRuleAuth',1);"><span><fmt:message key='rules.rulePriority.authPreRulesTab.txt' /></span></a></li>
                      <li id="postRuleAuthTab"><a href="JavaScript:swapGridContents('postRuleAuth',1);"><span><fmt:message key='rules.rulePriority.authPostRulesTab.txt' /></span></a></li>
					  <li id="preRuleVarTab"><a href="JavaScript:swapGridContents('preRuleVar',1);"><span><fmt:message key='rules.rulePriority.varPreRulesTab.txt' /></span></a></li>
                      <li id="postRuleVarTab"><a href="JavaScript:swapGridContents('postRuleVar',1);"><span><fmt:message key='rules.rulePriority.varPostRulesTab.txt' /></span></a></li>
                      <li id="preRuleQueueTab"><a href="JavaScript:swapGridContents('preRuleQueue',1);"><span><fmt:message key='rules.rulePriority.queuePreRulesTab.txt' /></span></a></li>
                      <li id="postRuleQueueTab"><a href="JavaScript:swapGridContents('postRuleQueue',1);"><span><fmt:message key='rules.rulePriority.queuePostRulesTab.txt' /></span></a></li>
                    </c:if>
                  </ul>
               </div>
            </TH></TR>
         </THEAD>
         <TBODY><TR></TR><TR></TR>
         <TR ondblclick='processRequest("modifyRule","",true);'>
         <TD valign="top" style="background-color:#f0f1f2">
            <form name="ruleForm" id="ruleForm" action="<c:url value='/r_ruleDefinition.do'/>" method="post">

            <input type="hidden" name="method" value="saveRulePriority" />
            <input type="hidden" name="userId" value="${userId}" />

            <div id="preRuleAuthDiv" style="background-color:#f0f1f2;">
			           <ul class="sortable" id="sortablePreAuth" style="width:750px;">
			             <c:choose>
					         <c:when test="${not empty preRulesAuth}">
			                 	<c:forEach var="i" begin="0" end="${fn:length(preRulesAuth)}" step="1">
					                 <c:forEach var="rule" items="${preRulesAuth}" varStatus="status">
					                   <c:if test="${rule.executionOrderPriority==i}">
					                         <c:choose>
							 				    <c:when test="${rule.workflowState==workflow}">
  								                    <li class="ui-state-default" id="${rule.baseRuleId}_${rule.workflowState}" group="preRuleAuth" value="${rule.executionOrderPriority}"
  								                      onclick='handleRowSelection(${rule.id}, ${rule.baseRuleId}, ruleNames[${rule.id}], ${rule.version}, ${rule.lockVersion}, "${rule.workflowState}", this,"rowSelected",event);'>
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>
  								                      <c:choose>
  								                        <c:when test="${rule.transactionTableName=='custom'}">&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.customComponents.txt' /></c:when>
  								                        <c:otherwise>&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.component.txt' />: ${rule.transactionTableName}</c:otherwise>
  								                      </c:choose>
  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:when>
  								                  <c:otherwise>
  								              	     <li class="ui-state-default ui-state-disabled" id="${rule.baseRuleId}_${rule.workflowState}" group="preRuleAuth" value="${rule.executionOrderPriority}">
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>
  								                      <c:choose>
  								                        <c:when test="${rule.transactionTableName=='custom'}">&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.customComponents.txt' /></c:when>
  								                        <c:otherwise>&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.component.txt' />: ${rule.transactionTableName}</c:otherwise>
  								                      </c:choose>
  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:otherwise>
  								                </c:choose>
  								              </c:if>
  								            </c:forEach>
  							           </c:forEach>
  							       </c:when>
  							       <c:otherwise>
  							           <i align="right" style="font-size:10pt;" colspan="100%"><center><em><fmt:message key="rules.ruleListDetailContent.noRules.txt"/></center></em></i>
  							       </c:otherwise>
  							</c:choose>
			           </ul>
            </div>

            <div id="postRuleAuthDiv" style="display:none;background-color:#f0f1f2;">
         			  <ul class="sortable" id="sortablePostAuth" style="width:750px;">
         			    <c:choose>
					        <c:when test="${not empty postRulesAuth}">
			                    <c:forEach var="i" begin="0" end="${fn:length(postRulesAuth)}" step="1">
					               <c:forEach var="rule" items="${postRulesAuth}" varStatus="status">
					                   <c:if test="${rule.executionOrderPriority==i}">
					                       <c:choose>
							 				  <c:when test="${rule.workflowState==workflow}">
  								                    <li class="ui-state-default" id="${rule.baseRuleId}_${rule.workflowState}" group="postRuleAuth" value="${rule.executionOrderPriority}"
  								                      onclick='handleRowSelection(${rule.id}, ${rule.baseRuleId}, ruleNames[${rule.id}], ${rule.version}, ${rule.lockVersion}, "${rule.workflowState}", this,"rowSelected",event);'>
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>
  								                      <c:choose>
  								                        <c:when test="${rule.transactionTableName=='custom'}">&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.customComponents.txt' /></c:when>
  								                        <c:otherwise>&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.component.txt' />: ${rule.transactionTableName}</c:otherwise>
  								                      </c:choose>
  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:when>
  								                  <c:otherwise>
  								              	     <li class="ui-state-default ui-state-disabled" id="${rule.baseRuleId}_${rule.workflowState}" group="postRuleAuth" value="${rule.executionOrderPriority}">
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>
  								                      <c:choose>
  								                        <c:when test="${rule.transactionTableName=='custom'}">&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.customComponents.txt' /></c:when>
  								                        <c:otherwise>&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.component.txt' />: ${rule.transactionTableName}</c:otherwise>
  								                      </c:choose>
  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:otherwise>
  								                </c:choose>
  								              </c:if>
  								            </c:forEach>
  							           </c:forEach>
  							       </c:when>
  							       <c:otherwise>
  							           <i align="right" style="font-size:10pt;" colspan="100%"><center><em><fmt:message key="rules.ruleListDetailContent.noRules.txt"/></center></em></i>
  							       </c:otherwise>
  							   </c:choose>
			           </ul>
            </div>

            <div id="preRuleVarDiv" style="display:none;background-color:#f0f1f2;">
			           <ul class="sortable" id="sortablePreVar" style="width:750px;">
			             <c:choose>
					         <c:when test="${not empty preRulesVar}">
			                 	<c:forEach var="i" begin="0" end="${fn:length(preRulesVar)}" step="1">
					                 <c:forEach var="rule" items="${preRulesVar}" varStatus="status">
					                   <c:if test="${rule.executionOrderPriority==i}">
					                     <c:choose>
							 				  <c:when test="${rule.workflowState==workflow}">
  								                    <li class="ui-state-default" id="${rule.baseRuleId}_${rule.workflowState}" group="preRuleVar" value="${rule.executionOrderPriority}"
  								                      onclick='handleRowSelection(${rule.id}, ${rule.baseRuleId}, ruleNames[${rule.id}], ${rule.version}, ${rule.lockVersion}, "${rule.workflowState}", this,"rowSelected",event);'>
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>
  								                      <c:choose>
  								                        <c:when test="${rule.transactionTableName=='custom'}">&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.customComponents.txt' /></c:when>
  								                        <c:otherwise>&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.component.txt' />: ${rule.transactionTableName}</c:otherwise>
  								                      </c:choose>
  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:when>
  								                  <c:otherwise>
  								              	     <li class="ui-state-default ui-state-disabled" id="${rule.baseRuleId}_${rule.workflowState}" group="preRuleVar" value="${rule.executionOrderPriority}">
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>
  								                      <c:choose>
  								                        <c:when test="${rule.transactionTableName=='custom'}">&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.customComponents.txt' /></c:when>
  								                        <c:otherwise>&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.component.txt' />: ${rule.transactionTableName}</c:otherwise>
  								                      </c:choose>
  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:otherwise>
  								                </c:choose>
  								              </c:if>
  								            </c:forEach>
  							           </c:forEach>
  							       </c:when>
  							       <c:otherwise>
  							           <i align="right" style="font-size:10pt;" colspan="100%"><center><em><fmt:message key="rules.ruleListDetailContent.noRules.txt"/></center></em></i>
  							       </c:otherwise>
  						      </c:choose>
			           </ul>
            </div>

            <div id="postRuleVarDiv" style="display:none;background-color:#f0f1f2;">
         			  <ul class="sortable" id="sortablePostVar" style="width:750px;">
         			    <c:choose>
					        <c:when test="${not empty postRulesVar}">
			                     <c:forEach var="i" begin="0" end="${fn:length(postRulesVar)}" step="1">
					                 <c:forEach var="rule" items="${postRulesVar}" varStatus="status">
					                   <c:if test="${rule.executionOrderPriority==i}">
					                       <c:choose>
							 				   <c:when test="${rule.workflowState==workflow}">
  								                    <li class="ui-state-default" id="${rule.baseRuleId}_${rule.workflowState}" group="postRuleVar" value="${rule.executionOrderPriority}"
  								                      onclick='handleRowSelection(${rule.id}, ${rule.baseRuleId}, ruleNames[${rule.id}], ${rule.version}, ${rule.lockVersion}, "${rule.workflowState}", this,"rowSelected",event);'>
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>
  								                      <c:choose>
  								                        <c:when test="${rule.transactionTableName=='custom'}">&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.customComponents.txt' /></c:when>
  								                        <c:otherwise>&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.component.txt' />: ${rule.transactionTableName}</c:otherwise>
  								                      </c:choose>
  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:when>
  								                  <c:otherwise>
  								              	     <li class="ui-state-default ui-state-disabled" id="${rule.baseRuleId}_${rule.workflowState}" group="postRuleVar" value="${rule.executionOrderPriority}">
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>
  								                      <c:choose>
  								                        <c:when test="${rule.transactionTableName=='custom'}">&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.customComponents.txt' /></c:when>
  								                        <c:otherwise>&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.component.txt' />: ${rule.transactionTableName}</c:otherwise>
  								                      </c:choose>
  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:otherwise>
  								                </c:choose>
  								              </c:if>
  								            </c:forEach>
  							           </c:forEach>
  							      </c:when>
  							      <c:otherwise>
  							         <i align="right" style="font-size:10pt;" colspan="100%"><center><em><fmt:message key="rules.ruleListDetailContent.noRules.txt"/></center></em></i>
  							      </c:otherwise>
  							  </c:choose>
			           </ul>
            </div>

            <div id="preRuleQueueDiv" style="display:none;background-color:#f0f1f2;">
			           <ul class="sortable" id="sortablePreQueue" style="width:750px;">
			             <c:choose>
					        <c:when test="${not empty preRulesQueue}">
			                     <c:forEach var="i" begin="0" end="${fn:length(preRulesQueue)}" step="1">
					                 <c:forEach var="rule" items="${preRulesQueue}" varStatus="status">
					                   <c:if test="${rule.executionOrderPriority==i}">
					                     <c:choose>
							 				  <c:when test="${rule.workflowState==workflow}">
  								                    <li class="ui-state-default" id="${rule.baseRuleId}_${rule.workflowState}" group="preRuleQueue" value="${rule.executionOrderPriority}"
  								                      onclick='handleRowSelection(${rule.id}, ${rule.baseRuleId}, ruleNames[${rule.id}], ${rule.version}, ${rule.lockVersion}, "${rule.workflowState}", this,"rowSelected",event);'>
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>
  								                      <c:choose>
  								                        <c:when test="${rule.transactionTableName=='custom'}">&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.customComponents.txt' /></c:when>
  								                        <c:otherwise>&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.component.txt' />: ${rule.transactionTableName}</c:otherwise>
  								                      </c:choose>
  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:when>
  								                  <c:otherwise>
  								              	     <li class="ui-state-default ui-state-disabled" id="${rule.baseRuleId}_${rule.workflowState}" group="preRuleQueue" value="${rule.executionOrderPriority}">
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>
  								                      <c:choose>
  								                        <c:when test="${rule.transactionTableName=='custom'}">&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.customComponents.txt' /></c:when>
  								                        <c:otherwise>&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.component.txt' />: ${rule.transactionTableName}</c:otherwise>
  								                      </c:choose>
  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:otherwise>
  								                </c:choose>
  								              </c:if>
  								            </c:forEach>
  							          </c:forEach>
  							    </c:when>
  							    <c:otherwise>
  							       <i align="right" style="font-size:10pt;" colspan="100%"><center><em><fmt:message key="rules.ruleListDetailContent.noRules.txt"/></center></em></i>
  							    </c:otherwise>
  							</c:choose>
			           </ul>
            </div>

            <div id="postRuleQueueDiv" style="display:none;background-color:#f0f1f2;">
         			  <ul class="sortable" id="sortablePostQueue" style="width:750px;">
         			    <c:choose>
					        <c:when test="${not empty postRulesQueue}">
			                     <c:forEach var="i" begin="0" end="${fn:length(postRulesQueue)}" step="1">
					                 <c:forEach var="rule" items="${postRulesQueue}" varStatus="status">
					                   <c:if test="${rule.executionOrderPriority==i}">
					                      <c:choose>
							 				   <c:when test="${rule.workflowState==workflow}">
  								                    <li class="ui-state-default" id="${rule.baseRuleId}_${rule.workflowState}" group="postRuleQueue" value="${rule.executionOrderPriority}"
  								                      onclick='handleRowSelection(${rule.id}, ${rule.baseRuleId}, ruleNames[${rule.id}], ${rule.version}, ${rule.lockVersion}, "${rule.workflowState}", this,"rowSelected",event);'>
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>
  								                      <c:choose>
  								                        <c:when test="${rule.transactionTableName=='custom'}">&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.customComponents.txt' /></c:when>
  								                        <c:otherwise>&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.component.txt' />: ${rule.transactionTableName}</c:otherwise>
  								                      </c:choose>
  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:when>
  								                  <c:otherwise>
  								              	     <li class="ui-state-default ui-state-disabled" id="${rule.baseRuleId}_${rule.workflowState}" group="postRuleQueue" value="${rule.executionOrderPriority}">
  								                      [${rule.workflowState}]&nbsp;&nbsp;&nbsp;&nbsp;<b>${rule.baseRuleId}.${rule.version} / ${rule.name}</b>
  								                      <c:choose>
  								                        <c:when test="${rule.transactionTableName=='custom'}">&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.customComponents.txt' /></c:when>
  								                        <c:otherwise>&nbsp;&nbsp;&nbsp;&nbsp;<fmt:message key='rules.rulePriority.component.txt' />: ${rule.transactionTableName}</c:otherwise>
  								                      </c:choose>
  								                      <c:if test="${not empty rule.ruleDependencies}">&nbsp;&nbsp;&nbsp;&nbsp;<font color="red"><fmt:message key='rules.rulePriority.dependencies.txt' />: </font>${rule.ruleDependencies}</c:if>
  								                    </li>
  								                  </c:otherwise>
  								                </c:choose>
  								              </c:if>
  								            </c:forEach>
  							           </c:forEach>
  							      </c:when>
  							      <c:otherwise>
  							         <i align="right" style="font-size:10pt;" colspan="100%"><center><em><fmt:message key="rules.ruleListDetailContent.noRules.txt"/></center></em></i>
  							      </c:otherwise>
  							  </c:choose>
			           </ul>
            </div>

            </form>

         </TD></TR></TBODY>
      </table>
</div>
