<%@ include file="/common/taglibs.jsp" %>
<%@ page contentType="text/html; charset=UTF-8" %>
   <style type="text/css">@import "common/styles/sasStyles.css";</style>
   <style type="text/css">@import "includes/view.css";</style>
   <script language="JavaScript" src="includes/view.js"></script>
   <script language="JavaScript" src="common/scripts/tree.js"></script>
   <script language="JavaScript" src="rules/scripts/variables.js"></script>
   <script language="JavaScript" src="rules/scripts/lookupLists.js"></script>


<!-- Tree header. -->
<div style="padding:1px;"><div id="navhead" class="mmhide_navhd" style="height:15px;"><span style="padding:2px;vertical-align:-3px;"><fmt:message key='console.consoleOverviewContent.title.txt'/></span></div></div>


<!-- Nested tables with fixed height -->
<table id="overview_table" cellspacing=0 cellpadding=2 border="0"  >
   <tr>
      <td id="navcol" align="left" valign="top" nowrap>

<script language="JavaScript">
//<!--

   function show(detailAction, refreshAction, lookupAction, activityAction)
   {
     var selectedNode = _consoleTree.getSelectedNodes()[0];
     if (!selectedNode)
        return;
     var params = selectedNode.parameters;
     if (!params)
        return;
     params = params.split(",");
     var method = params[0];
     var type = params[1];     
     var serverHost=params[2];
     var title = params[2];
     if(params.length>3) var dataSource= params[3];
     if (!method)
        return;
     var action = detailAction + '?method=' + method;
     var value;
     if (method=="abortAgs")
     {
        if (!confirm("Click 'OK' to abort all alert engine processing\n\n" +
                     "or click 'Cancel' to continue processing.\n"))
          return;
     }
     else if (method=="quiesceAgs")
     {
        if (!confirm("Click 'OK' to quiesce the alert engine\n\n" +
                     "or click 'Cancel' to continue processing.\n"))
          return;
     }
     else if (method=="reloadQueue")
     {
        if (!confirm("Click 'OK' to reload queue-related information in the alert engine\n\n" +
                     "or click 'Cancel' to continue processing.\n"))
          return;
     }
     else if (method=="reloadQueueRule")
     {
        if (!confirm("Click 'OK' to reload queue-related information, rule code, and lookup lists in the alert engine\n\n" +
                     "or click 'Cancel' to continue processing.\n"))
          return;
     }
     else if (method=="stopAgs")
     {
        if (!confirm("Click 'OK' to do an orderly shutdown of the alert engine\n\n" +
                     "or click 'Cancel' to continue processing.\n"))
          return;
     }
     else if (method=="restartAgs")
     {
        if (!confirm("Click 'OK' to shutdown the alert engine and immediately restart it\n\n" +
                     "or click 'Cancel' to continue processing.\n"))
          return;
     }
     else if (method=="disableEtl")
     {
        if (!confirm("Disabling ETL processing causes transactions to not be archived in the reporting history database.\n\n" +
                     "Click 'OK' to stop queuing transactions for archive or click 'Cancel' to continue normal processing.\n"))
          return;
     }
     else if (method=="enableTrace")
     {
        if (!confirm("Enabling trace mode can significantly degrade alert engine performance.\n\n" +
                     "Click 'OK' to start tracing or click 'Cancel' to continue normal processing.\n"))
          return;
     }
     else if (method=="traceAgs")
     {
        if (!confirm("Running the alert engine in trace mode can significantly degrade its performance.\n\n" +
                     "Click 'OK' to start the alert engine with tracing or click 'Cancel' to do nothing.\n"))
          return;
     }
     else if (method=="queryAgs")
     {
        var choices = new Array();
        choices[choices.length] = choices.length + "=None";
        choices[choices.length] = choices.length + "=AGSMain";
        choices[choices.length] = choices.length + "=AGSMessageProcessor";
        choices[choices.length] = choices.length + "=AGSThreadPool";
        choices[choices.length] = choices.length + "=AGSUscMonitor";
        choices[choices.length] = choices.length + "=AGSMessageStats";
        var choice = prompt("Select alert engine internal values to display: " + choices.join(" "),"");
        if (choice<1 || choice>choices.length)
           return;
        value = choices[choice].split(" ")[2];
     }
     else if (method=="playRecording")
        action = activityAction + '?method=' + method;
     else if (method=="monPerf") {
        action = activityAction + '?method=' + method + "&barsPerPage=" + getCookie('console_barsPerPage');
     }
     else if (method=="showLookupLists")
     {
        showLookupLists(lookupAction,'AGE');
        return;
     }
     else if (method=="notyet")
     {
        alert("Not yet available!");
        return;
     }


     if (method=="refresh")
     {
        if(params.length<3)
        	action = refreshAction + "&openFolder=" + type;
        parent.frames[ "overview" ].location.href = action;
     }
     else if(method=='showJvmLog' || method=='showSasLog'){
        action += "&ags=" + params[1] + "&agsLabel=" + params[2] + "&type=" + params[3];
        parent.frames[ "detail" ].location.href = action;
     }
     else if (method=="showDeployment")
     {
        action= detailAction + '?method=' + method + "&deployableTarget=" + params[1] + "&multiOrgNodeKey=" + params[2];
        parent.frames[ "detail" ].location.href = action;
     }
     else
     {
        if (value)
           action += "&value=" + value;
        if (type)
           action += "&type=" + type;
        if (serverHost)
            action += "&serverHost=" + serverHost;
        if (title)
           action += "&title=" + title;
        if (dataSource){
           action += "&dataSource=" + dataSource;
        }

        parent.frames[ "detail" ].location.href = action;
     }

   }


   function hideBusy()
   {
      var windowObj = (top != self) ? top : self;
      var frameDiv = windowObj.document.getElementById("frameDiv");
      if(frameDiv)
         frameDiv.style.display="none";

      var busyMsgTop = windowObj.document.getElementById("busyMessageDiv");
      if(busyMsgTop)
         busyMsgTop.style.display="none";
   }
   hideBusy();


   // Remove padding so menubar appears to be glued to the top
   document.body.style.padding = "0";
   document.getElementById("navhead").style.padding = "0";

    // To identify new or modified objects
   var _selectedObject = '';

   var _consoleNodes = new Array();
   var _notyet = "notyet";

   // CheatSheet: function Node( nodeId, parentId, image, title, tip, parameters, state, italic, owner )
   _consoleNodes[_consoleNodes.length] = new Node("pipe",         0,          "folder",        "<fmt:message key='console.consoleOverviewContent.deploy.transactionPipeline.txt'/>", "Transaction Pipeline", "",               "", "", "");


   _consoleNodes[_consoleNodes.length] = new Node("deployment",   "pipe",   "folder","<fmt:message key='console.consoleOverviewContent.deploy.deploy.txt'/>",               "Deploy",               "",               "", "", "");
	<c:forEach var="dPackage" items="${deploymentPackages}" varStatus="ii">
	<c:if test="${ii.first}">_selectedObject='deploy_${fn:trim(dPackage.key)}';</c:if>
  	 _consoleNodes[_consoleNodes.length] = new Node("deploy_${fn:trim(dPackage.key)}", "deployment",  "DeployedJob", "${dPackage.decoratedName}","${dPackage.descriptionOfChanges}", "showDeployment,${fn:trim(dPackage.name)} (${fn:trim(dPackage.key)}),${dPackage.key}","", "", "");
	</c:forEach>


   _consoleNodes[_consoleNodes.length] = new Node("monitor",      "pipe",     "folder",        "<fmt:message key='console.consoleOverviewContent.monitor.monitor.txt'/>",              "Monitor",              "",               "", "", "");
   _consoleNodes[_consoleNodes.length] = new Node("ping",         "monitor",  "query",          "<fmt:message key='console.consoleOverviewContent.monitor.status.txt'/>",               "Status",               "pingServers",        "", "", "");

   //_consoleNodes[_consoleNodes.length] = new Node("monAll",       "monitor",        "RunningPersons", "<fmt:message key='console.consoleOverviewContent.monitor.allActivity.txt'/>",    "Display combined activity of both engines",        "monPerf",     "", "", "");
   <c:if test="${isJOSE==true}">
     _consoleNodes[_consoleNodes.length] = new Node("monOse",       "monitor",        "RunningPerson",  "<fmt:message key='console.consoleOverviewContent.monitor.scoringActivity.txt'/>","Display activity of the SAS Online Scoring Engine","", "", "", "");
     <c:forEach var="oseServer" items="${oseServers}" varStatus="ii">
       _consoleNodes[_consoleNodes.length] = new Node("${oseServer.host}",       "monOse",        "RunningPerson",  "${oseServer.host}","Display activity of the SAS Online Scoring Engine","monPerf,JOSE,${oseServer.host}", "", "", "");
     </c:forEach>
   </c:if>
   <c:if test="${isJOSE==false}">
     _consoleNodes[_consoleNodes.length] = new Node("monOse",       "monitor",        "RunningPerson",  "<fmt:message key='console.consoleOverviewContent.monitor.scoringActivity.txt'/>","Display activity of the SAS Online Scoring Engine","monPerf,OSE", "", "", "");
     _consoleNodes[_consoleNodes.length] = new Node("monAgs",       "monitor",        "RunningPerson",  "<fmt:message key='console.consoleOverviewContent.monitor.alertActivity.txt'/>",  "Display combined activity of the Alert Engine",    "", "", "", "");
     <c:forEach var="agsServer" items="${agsServers}" varStatus="ii">
       _consoleNodes[_consoleNodes.length] = new Node("${agsServer.host}",       "monAgs",        "RunningPerson",  "${agsServer.host}","Display activity of the SAS Online Scoring Engine","monPerf,AGS,${agsServer.host}", "", "", "");
     </c:forEach>
   </c:if>
  // _consoleNodes[_consoleNodes.length] = new Node("oseEngineLog",       "monitor",  "estimate0",      "Scoring Engine Log",   "Show the most recently updated scoring engine log","","", "", "");
  // _consoleNodes[_consoleNodes.length] = new Node("jvmLog",       "monitor",  "estimate0",      "Alert Engine Controller Log",   "Show the most recently updated alert engine JVM log","showJvmLog","", "", "");
  // _consoleNodes[_consoleNodes.length] = new Node("sasLog",       "monitor",  "estimate0",      "Alert Engine SAS Log",          "Show the most recently updated alert engine SAS log","showSasLog","", "", "");
  // _consoleNodes[_consoleNodes.length] = new Node("etlcontLog",       "monitor",  "estimate0",      "ETL Controller Log",              "Show the most recently updated ETL Controller Log","","", "", "");
  //_consoleNodes[_consoleNodes.length] = new Node("etlkeymangLog",       "monitor",  "estimate0",      "ETL Key Manager Log",              "Show the most recently updated ETL Key Manager Log","","", "", "");
  // _consoleNodes[_consoleNodes.length] = new Node("etlbatchLog",       "monitor",  "estimate0",      "ETL Batch Loader Log",              "Show the most recently updated ETL Batch Loader Log","","", "", "");
  // _consoleNodes[_consoleNodes.length] = new Node("etleventLog",       "monitor",  "estimate0",      "ETL Event Log",              "Show the most recently updated ETL Event Log","","", "", "");

   _consoleNodes[_consoleNodes.length] = new Node("inspect",      "pipe",      "folder",       "<fmt:message key='console.consoleOverviewContent.inspect.inspect.txt'/>",              "Inspect",              "",               "", "", "");
//   _consoleNodes[_consoleNodes.length] = new Node("logs",         "inspect",   "folder",       "<fmt:message key='console.consoleOverviewContent.inspect.logs.txt'/>",                 "Pipeline Process Logs",                  "","", "", "");

   //BREAK DOWN PER AGS INSTANCE
//   <c:forEach var="instance" items="${agsInstances}" varStatus="inst">
//   		_consoleNodes[_consoleNodes.length] = new Node("${instance.instanceName}",         "logs",   "folder",       "${instance.instanceLabel}",                 "Pipeline Process Logs ${instance.instanceLabel}",                  "","", "", "");
 		//  _consoleNodes[_consoleNodes.length] = new Node("oseEngineLogFolder",       "logs",  "folder",      "Scoring Engine Log",   "Show the most recently updated scoring engine log","","", "", "");
        //_consoleNodes[_consoleNodes.length] = new Node("jvmLogs",      "logs",      "folder0",        "Alert Engine Controller Logs", "Refresh the list of alert engine Controller Logs",  "refresh,jvmLogs","", "", "");
		//_consoleNodes[_consoleNodes.length] = new Node("${instance.instanceName}jvmLogs",      "${instance.instanceName}",      "folder",        "${instance.instanceLabel} Controller Logs", "Refresh the list of alert engine Controller Logs",  "",               "", "", "");

//		<c:forEach var="logFile" items="${jvmLogs[inst.index]}" varStatus="status">
//	   		_consoleNodes[_consoleNodes.length] = new Node("${instance.instanceName}Jvm${status.index}","${instance.instanceName}jvmLogs","estimate0","${logFile}",           "${logFile}",           "showJvmLog,${instance.instanceName},${instance.instanceLabel},${logFile}","", "", "");
//		</c:forEach>

//   </c:forEach>

   //   _consoleNodes[_consoleNodes.length] = new Node("etlcontLogFolder",       "logs",  "folder",      "ETL Controller Log",              "Show the most recently updated ETL Controller Log","","", "", "");
   //   _consoleNodes[_consoleNodes.length] = new Node("etlkeymangLogFolder",       "logs",  "folder",      "ETL Key Manager Log",              "Show the most recently updated ETL Key Manager Log","","", "", "");
   //   _consoleNodes[_consoleNodes.length] = new Node("etlbatchLogFolder",       "logs",  "folder",      "ETL Batch Loader Log",              "Show the most recently updated ETL Batch Loader Log","","", "", "");
   //   _consoleNodes[_consoleNodes.length] = new Node("etleventLogFolder",       "logs",  "folder",      "ETL Event Log",              "Show the most recently updated ETL Event Log","","", "", "");


   _consoleNodes[_consoleNodes.length] = new Node("recordings",   "inspect",   "folder",        "<fmt:message key='console.consoleOverviewContent.inspect.recordings.txt'/>",          "Refresh the list of recordings",           "",               "", "", "");
   <c:forEach var="r" begin="1" end="${fn:length(recordings)}">
     <c:set var="recording" value="${recordings[fn:length(recordings)-r]}"/>
      _consoleNodes[_consoleNodes.length] = new Node("recording${r}","recordings","DeployedJob",   "${recording}",        "${recording}",         "playRecording,${recording}","", "", "");
   </c:forEach>


   _consoleNodes[_consoleNodes.length] = new Node("config",       "pipe",      "folder",       "<fmt:message key='console.consoleOverviewContent.configureProperties.configureProperties.txt'/>",            "Configure",              "",               "", "", "");
   <%-- Disabling etl support in 3.1
   _consoleNodes[_consoleNodes.length] = new Node("uscprop",      "config",    "browse",        "USC",       "Examine USC configuration properties",                                       "viewProperties,USC",  "", "", "");
   --%>
   _consoleNodes[_consoleNodes.length] = new Node("consoleprop",      "config",    "edit",          "<fmt:message key='console.consoleOverviewContent.configureProperties.consoleProperties.txt'/>",       "Set property values (does not affect running system until restart)",         "viewProperties,Console",  "", "", "");
   <%--
   _consoleNodes[_consoleNodes.length] = new Node("agsprop",      "config",    "edit",          "<fmt:message key='console.consoleOverviewContent.configureProperties.alertEngineProperties.txt'/>",       "Set property values (does not affect running system until restart)",         "viewProperties,AGS",  "", "", "");
   --%>
   <%-- Disabling etl support in 3.1
   _consoleNodes[_consoleNodes.length] = new Node("etlprop",      "config",    "edit",          "ETL Properties",       "Set property values (does not affect running system until restart)",         "viewProperties,ETL",  "", "", "");
   --%>
   <%--
   <c:if test="${mehAvail==true}">
   	_consoleNodes[_consoleNodes.length] = new Node("oseprop",      "config",    "folder",          "<fmt:message key='console.consoleOverviewContent.configureProperties.scoringEngineProperties.txt'/>", "Set property values (does not affect running system until restart)"       ,"",  "", "", "");

	   <c:forEach var="propertyTypes" items="${mehPropertyTypes}" varStatus="p">
	   <c:set var="message"><fmt:message key='fcm.preferences.property.type.${fn:replace(propertyTypes.propertyType,"/","")}.txt'/></c:set>
	   _consoleNodes[_consoleNodes.length] = new Node("meh${propertyTypes.propertyType}",      "oseprop",    "folder",          "${message}",       "View ${message}" ,"viewProperties,${propertyTypes.propertyType},OSE,MEH",  "", "", "");
	   </c:forEach>
    </c:if>
    --%>
    <c:if test="${rhAvail==true}">
	   _consoleNodes[_consoleNodes.length] = new Node("rhprop",      "config",    "folder",          "<fmt:message key='console.consoleOverviewContent.configureProperties.reportingHistoryProperties.txt'/>", "Set property values (does not affect running system until restart)"       ,"",  "", "", "");
	   <c:forEach var="propertyTypes" items="${rhPropertyTypes}" varStatus="p">
	   <c:set var="message"><fmt:message key='fcm.preferences.property.type.${fn:replace(propertyTypes.propertyType,"/","")}.txt'/></c:set>
	   _consoleNodes[_consoleNodes.length] = new Node("rh${propertyTypes.propertyType}",      "rhprop",    "folder",          "${message}",       "View ${message}" ,"viewProperties,${propertyTypes.propertyType},RH,RH",  "", "", "");
	   </c:forEach>
   </c:if>
   _consoleNodes[_consoleNodes.length]  = new Node("sysmon", 0, "folder","<fmt:message key='fcm.monitor.alertManagementIntegrationPoint.txt'/>", "<fmt:message key='fcm.monitor.alertManagementIntegrationPoint.txt'/>","","","","");
   _consoleNodes[_consoleNodes.length] = new Node(_consoleNodes.length,"sysmon", "edit","<fmt:message key='fcm.monitor.alertManagementFulfillmentSubmissionMonitor.txt'/>", "<fmt:message key='fcm.monitor.alertManagementFulfillmentSubmissionMonitor.txt'/>","viewMessageFailures,FULFILLMENT","", "", "");
   _consoleNodes[_consoleNodes.length] = new Node(_consoleNodes.length,"sysmon", "edit","<fmt:message key='fcm.monitor.alertManagementECMSubmissionMonitor.txt'/>", "<fmt:message key='fcm.monitor.alertManagementECMSubmissionMonitor.txt'/>","viewMessageFailures,ECMI","", "", "");

   var detailAction = '<c:url value="/r_console.do"/>' ;
   var activityAction = '<c:url value="/r_consoleActivity.do"/>' ;
   var lookupAction = '<c:url value="/r_lookupLists.do"/>' ;
   var refreshAction = '<c:url value="/r_console.do?method=showOverview"/>';

   var openFolders = "pipe|deployment|monitor|inspect|config";
   if ("recordings" === "${param.openFolder}")
      openFolders += "|recordings";
   <c:forEach var="instance" items="${agsInstances}" varStatus="inst">
	   else if ("${instance.instanceName}jvmLogs" == "${param.openFolder}")
	      openFolders += "|${instance.instanceName}jvmLogs|${instance.instanceName}|logs";
	   else if ("${instance.instanceName}sasLogs" == "${param.openFolder}")
	      openFolders += "|${instance.instanceName}sasLogs|${instance.instanceName}|logs";
   </c:forEach>

   // Cheatsheet: function Tree( name, nodes, start, open, selected, eventHandler, extend, location, enabled, treeImages, nodeImages )
   _consoleTree = new Tree("_consoleTree", _consoleNodes, 0, openFolders, _selectedObject, "show(detailAction, refreshAction, lookupAction, activityAction, _consoleNodes);",
                             false, false, true, "common/images/tree/", "images/rules/" );

   // Show selected node
   show(detailAction, refreshAction, lookupAction, activityAction);


//-->
</script>

 </td>
   </tr>
</table>



